Commit c299ec2d8e8d2f1a99d5c993fca485257b950d40

Authored by Alex Landau
Committed by Sam Ravnborg
1 parent b4d5171ac7

kbuild: handle compressed cpio initramfs-es

Make kbuild handle compressed cpio initramfs-es.  An already compressed
cpio is copied directly to usr/, while a non-compressed cpio is filtered
through gzip (no changes here) on its way to usr/.

If the user has created a compressed cpio by other means, this saves him
from uncompressing it, just to be compressed again by kbuild.

Signed-off-by: Alex Landau <landau.alex@gmail.com>
Signed-off-by: Andrew Morton <akpm@linux-foundation.org>
Signed-off-by: Sam Ravnborg <sam@ravnborg.org>

Showing 1 changed file with 8 additions and 2 deletions Inline Diff

scripts/gen_initramfs_list.sh
1 #!/bin/bash 1 #!/bin/bash
2 # Copyright (C) Martin Schlemmer <azarah@nosferatu.za.org> 2 # Copyright (C) Martin Schlemmer <azarah@nosferatu.za.org>
3 # Copyright (C) 2006 Sam Ravnborg <sam@ravnborg.org> 3 # Copyright (C) 2006 Sam Ravnborg <sam@ravnborg.org>
4 # 4 #
5 # Released under the terms of the GNU GPL 5 # Released under the terms of the GNU GPL
6 # 6 #
7 # Generate a cpio packed initramfs. It uses gen_init_cpio to generate 7 # Generate a cpio packed initramfs. It uses gen_init_cpio to generate
8 # the cpio archive, and gzip to pack it. 8 # the cpio archive, and gzip to pack it.
9 # The script may also be used to generate the inputfile used for gen_init_cpio 9 # The script may also be used to generate the inputfile used for gen_init_cpio
10 # This script assumes that gen_init_cpio is located in usr/ directory 10 # This script assumes that gen_init_cpio is located in usr/ directory
11 11
12 # error out on errors 12 # error out on errors
13 set -e 13 set -e
14 14
15 usage() { 15 usage() {
16 cat << EOF 16 cat << EOF
17 Usage: 17 Usage:
18 $0 [-o <file>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ... 18 $0 [-o <file>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
19 -o <file> Create gzipped initramfs file named <file> using 19 -o <file> Create gzipped initramfs file named <file> using
20 gen_init_cpio and gzip 20 gen_init_cpio and gzip
21 -u <uid> User ID to map to user ID 0 (root). 21 -u <uid> User ID to map to user ID 0 (root).
22 <uid> is only meaningful if <cpio_source> 22 <uid> is only meaningful if <cpio_source>
23 is a directory. 23 is a directory.
24 -g <gid> Group ID to map to group ID 0 (root). 24 -g <gid> Group ID to map to group ID 0 (root).
25 <gid> is only meaningful if <cpio_source> 25 <gid> is only meaningful if <cpio_source>
26 is a directory. 26 is a directory.
27 <cpio_source> File list or directory for cpio archive. 27 <cpio_source> File list or directory for cpio archive.
28 If <cpio_source> is a .cpio file it will be used 28 If <cpio_source> is a .cpio file it will be used
29 as direct input to initramfs. 29 as direct input to initramfs.
30 -d Output the default cpio list. 30 -d Output the default cpio list.
31 31
32 All options except -o and -l may be repeated and are interpreted 32 All options except -o and -l may be repeated and are interpreted
33 sequentially and immediately. -u and -g states are preserved across 33 sequentially and immediately. -u and -g states are preserved across
34 <cpio_source> options so an explicit "-u 0 -g 0" is required 34 <cpio_source> options so an explicit "-u 0 -g 0" is required
35 to reset the root/group mapping. 35 to reset the root/group mapping.
36 EOF 36 EOF
37 } 37 }
38 38
39 # awk style field access 39 # awk style field access
40 # $1 - field number; rest is argument string 40 # $1 - field number; rest is argument string
41 field() { 41 field() {
42 shift $1 ; echo $1 42 shift $1 ; echo $1
43 } 43 }
44 44
45 list_default_initramfs() { 45 list_default_initramfs() {
46 # echo usr/kinit/kinit 46 # echo usr/kinit/kinit
47 : 47 :
48 } 48 }
49 49
50 default_initramfs() { 50 default_initramfs() {
51 cat <<-EOF >> ${output} 51 cat <<-EOF >> ${output}
52 # This is a very simple, default initramfs 52 # This is a very simple, default initramfs
53 53
54 dir /dev 0755 0 0 54 dir /dev 0755 0 0
55 nod /dev/console 0600 0 0 c 5 1 55 nod /dev/console 0600 0 0 c 5 1
56 dir /root 0700 0 0 56 dir /root 0700 0 0
57 # file /kinit usr/kinit/kinit 0755 0 0 57 # file /kinit usr/kinit/kinit 0755 0 0
58 # slink /init kinit 0755 0 0 58 # slink /init kinit 0755 0 0
59 EOF 59 EOF
60 } 60 }
61 61
62 filetype() { 62 filetype() {
63 local argv1="$1" 63 local argv1="$1"
64 64
65 # symlink test must come before file test 65 # symlink test must come before file test
66 if [ -L "${argv1}" ]; then 66 if [ -L "${argv1}" ]; then
67 echo "slink" 67 echo "slink"
68 elif [ -f "${argv1}" ]; then 68 elif [ -f "${argv1}" ]; then
69 echo "file" 69 echo "file"
70 elif [ -d "${argv1}" ]; then 70 elif [ -d "${argv1}" ]; then
71 echo "dir" 71 echo "dir"
72 elif [ -b "${argv1}" -o -c "${argv1}" ]; then 72 elif [ -b "${argv1}" -o -c "${argv1}" ]; then
73 echo "nod" 73 echo "nod"
74 elif [ -p "${argv1}" ]; then 74 elif [ -p "${argv1}" ]; then
75 echo "pipe" 75 echo "pipe"
76 elif [ -S "${argv1}" ]; then 76 elif [ -S "${argv1}" ]; then
77 echo "sock" 77 echo "sock"
78 else 78 else
79 echo "invalid" 79 echo "invalid"
80 fi 80 fi
81 return 0 81 return 0
82 } 82 }
83 83
84 list_print_mtime() { 84 list_print_mtime() {
85 : 85 :
86 } 86 }
87 87
88 print_mtime() { 88 print_mtime() {
89 local my_mtime="0" 89 local my_mtime="0"
90 90
91 if [ -e "$1" ]; then 91 if [ -e "$1" ]; then
92 my_mtime=$(find "$1" -printf "%T@\n" | sort -r | head -n 1) 92 my_mtime=$(find "$1" -printf "%T@\n" | sort -r | head -n 1)
93 fi 93 fi
94 94
95 echo "# Last modified: ${my_mtime}" >> ${output} 95 echo "# Last modified: ${my_mtime}" >> ${output}
96 echo "" >> ${output} 96 echo "" >> ${output}
97 } 97 }
98 98
99 list_parse() { 99 list_parse() {
100 echo "$1 \\" 100 echo "$1 \\"
101 } 101 }
102 102
103 # for each file print a line in following format 103 # for each file print a line in following format
104 # <filetype> <name> <path to file> <octal mode> <uid> <gid> 104 # <filetype> <name> <path to file> <octal mode> <uid> <gid>
105 # for links, devices etc the format differs. See gen_init_cpio for details 105 # for links, devices etc the format differs. See gen_init_cpio for details
106 parse() { 106 parse() {
107 local location="$1" 107 local location="$1"
108 local name="${location/${srcdir}//}" 108 local name="${location/${srcdir}//}"
109 # change '//' into '/' 109 # change '//' into '/'
110 name="${name//\/\///}" 110 name="${name//\/\///}"
111 local mode="$2" 111 local mode="$2"
112 local uid="$3" 112 local uid="$3"
113 local gid="$4" 113 local gid="$4"
114 local ftype=$(filetype "${location}") 114 local ftype=$(filetype "${location}")
115 # remap uid/gid to 0 if necessary 115 # remap uid/gid to 0 if necessary
116 [ "$uid" -eq "$root_uid" ] && uid=0 116 [ "$uid" -eq "$root_uid" ] && uid=0
117 [ "$gid" -eq "$root_gid" ] && gid=0 117 [ "$gid" -eq "$root_gid" ] && gid=0
118 local str="${mode} ${uid} ${gid}" 118 local str="${mode} ${uid} ${gid}"
119 119
120 [ "${ftype}" == "invalid" ] && return 0 120 [ "${ftype}" == "invalid" ] && return 0
121 [ "${location}" == "${srcdir}" ] && return 0 121 [ "${location}" == "${srcdir}" ] && return 0
122 122
123 case "${ftype}" in 123 case "${ftype}" in
124 "file") 124 "file")
125 str="${ftype} ${name} ${location} ${str}" 125 str="${ftype} ${name} ${location} ${str}"
126 ;; 126 ;;
127 "nod") 127 "nod")
128 local dev=`LC_ALL=C ls -l "${location}"` 128 local dev=`LC_ALL=C ls -l "${location}"`
129 local maj=`field 5 ${dev}` 129 local maj=`field 5 ${dev}`
130 local min=`field 6 ${dev}` 130 local min=`field 6 ${dev}`
131 maj=${maj%,} 131 maj=${maj%,}
132 132
133 [ -b "${location}" ] && dev="b" || dev="c" 133 [ -b "${location}" ] && dev="b" || dev="c"
134 134
135 str="${ftype} ${name} ${str} ${dev} ${maj} ${min}" 135 str="${ftype} ${name} ${str} ${dev} ${maj} ${min}"
136 ;; 136 ;;
137 "slink") 137 "slink")
138 local target=`field 11 $(LC_ALL=C ls -l "${location}")` 138 local target=`field 11 $(LC_ALL=C ls -l "${location}")`
139 str="${ftype} ${name} ${target} ${str}" 139 str="${ftype} ${name} ${target} ${str}"
140 ;; 140 ;;
141 *) 141 *)
142 str="${ftype} ${name} ${str}" 142 str="${ftype} ${name} ${str}"
143 ;; 143 ;;
144 esac 144 esac
145 145
146 echo "${str}" >> ${output} 146 echo "${str}" >> ${output}
147 147
148 return 0 148 return 0
149 } 149 }
150 150
151 unknown_option() { 151 unknown_option() {
152 printf "ERROR: unknown option \"$arg\"\n" >&2 152 printf "ERROR: unknown option \"$arg\"\n" >&2
153 printf "If the filename validly begins with '-', " >&2 153 printf "If the filename validly begins with '-', " >&2
154 printf "then it must be prefixed\n" >&2 154 printf "then it must be prefixed\n" >&2
155 printf "by './' so that it won't be interpreted as an option." >&2 155 printf "by './' so that it won't be interpreted as an option." >&2
156 printf "\n" >&2 156 printf "\n" >&2
157 usage >&2 157 usage >&2
158 exit 1 158 exit 1
159 } 159 }
160 160
161 list_header() { 161 list_header() {
162 : 162 :
163 } 163 }
164 164
165 header() { 165 header() {
166 printf "\n#####################\n# $1\n" >> ${output} 166 printf "\n#####################\n# $1\n" >> ${output}
167 } 167 }
168 168
169 # process one directory (incl sub-directories) 169 # process one directory (incl sub-directories)
170 dir_filelist() { 170 dir_filelist() {
171 ${dep_list}header "$1" 171 ${dep_list}header "$1"
172 172
173 srcdir=$(echo "$1" | sed -e 's://*:/:g') 173 srcdir=$(echo "$1" | sed -e 's://*:/:g')
174 dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n" 2>/dev/null) 174 dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n" 2>/dev/null)
175 175
176 # If $dirlist is only one line, then the directory is empty 176 # If $dirlist is only one line, then the directory is empty
177 if [ "$(echo "${dirlist}" | wc -l)" -gt 1 ]; then 177 if [ "$(echo "${dirlist}" | wc -l)" -gt 1 ]; then
178 ${dep_list}print_mtime "$1" 178 ${dep_list}print_mtime "$1"
179 179
180 echo "${dirlist}" | \ 180 echo "${dirlist}" | \
181 while read x; do 181 while read x; do
182 ${dep_list}parse ${x} 182 ${dep_list}parse ${x}
183 done 183 done
184 fi 184 fi
185 } 185 }
186 186
187 # if only one file is specified and it is .cpio file then use it direct as fs 187 # if only one file is specified and it is .cpio file then use it direct as fs
188 # if a directory is specified then add all files in given direcotry to fs 188 # if a directory is specified then add all files in given direcotry to fs
189 # if a regular file is specified assume it is in gen_initramfs format 189 # if a regular file is specified assume it is in gen_initramfs format
190 input_file() { 190 input_file() {
191 source="$1" 191 source="$1"
192 if [ -f "$1" ]; then 192 if [ -f "$1" ]; then
193 ${dep_list}header "$1" 193 ${dep_list}header "$1"
194 is_cpio="$(echo "$1" | sed 's/^.*\.cpio/cpio/')" 194 is_cpio="$(echo "$1" | sed 's/^.*\.cpio\(\..*\)\?/cpio/')"
195 if [ $2 -eq 0 -a ${is_cpio} == "cpio" ]; then 195 if [ $2 -eq 0 -a ${is_cpio} == "cpio" ]; then
196 cpio_file=$1 196 cpio_file=$1
197 echo "$1" | grep -q '^.*\.cpio\..*' && is_cpio_compressed="compressed"
197 [ ! -z ${dep_list} ] && echo "$1" 198 [ ! -z ${dep_list} ] && echo "$1"
198 return 0 199 return 0
199 fi 200 fi
200 if [ -z ${dep_list} ]; then 201 if [ -z ${dep_list} ]; then
201 print_mtime "$1" >> ${output} 202 print_mtime "$1" >> ${output}
202 cat "$1" >> ${output} 203 cat "$1" >> ${output}
203 else 204 else
204 cat "$1" | while read type dir file perm ; do 205 cat "$1" | while read type dir file perm ; do
205 if [ "$type" == "file" ]; then 206 if [ "$type" == "file" ]; then
206 echo "$file \\"; 207 echo "$file \\";
207 fi 208 fi
208 done 209 done
209 fi 210 fi
210 elif [ -d "$1" ]; then 211 elif [ -d "$1" ]; then
211 dir_filelist "$1" 212 dir_filelist "$1"
212 else 213 else
213 echo " ${prog}: Cannot open '$1'" >&2 214 echo " ${prog}: Cannot open '$1'" >&2
214 exit 1 215 exit 1
215 fi 216 fi
216 } 217 }
217 218
218 prog=$0 219 prog=$0
219 root_uid=0 220 root_uid=0
220 root_gid=0 221 root_gid=0
221 dep_list= 222 dep_list=
222 cpio_file= 223 cpio_file=
223 cpio_list= 224 cpio_list=
224 output="/dev/stdout" 225 output="/dev/stdout"
225 output_file="" 226 output_file=""
227 is_cpio_compressed=
226 228
227 arg="$1" 229 arg="$1"
228 case "$arg" in 230 case "$arg" in
229 "-l") # files included in initramfs - used by kbuild 231 "-l") # files included in initramfs - used by kbuild
230 dep_list="list_" 232 dep_list="list_"
231 echo "deps_initramfs := \\" 233 echo "deps_initramfs := \\"
232 shift 234 shift
233 ;; 235 ;;
234 "-o") # generate gzipped cpio image named $1 236 "-o") # generate gzipped cpio image named $1
235 shift 237 shift
236 output_file="$1" 238 output_file="$1"
237 cpio_list="$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)" 239 cpio_list="$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)"
238 output=${cpio_list} 240 output=${cpio_list}
239 shift 241 shift
240 ;; 242 ;;
241 esac 243 esac
242 while [ $# -gt 0 ]; do 244 while [ $# -gt 0 ]; do
243 arg="$1" 245 arg="$1"
244 shift 246 shift
245 case "$arg" in 247 case "$arg" in
246 "-u") # map $1 to uid=0 (root) 248 "-u") # map $1 to uid=0 (root)
247 root_uid="$1" 249 root_uid="$1"
248 shift 250 shift
249 ;; 251 ;;
250 "-g") # map $1 to gid=0 (root) 252 "-g") # map $1 to gid=0 (root)
251 root_gid="$1" 253 root_gid="$1"
252 shift 254 shift
253 ;; 255 ;;
254 "-d") # display default initramfs list 256 "-d") # display default initramfs list
255 default_list="$arg" 257 default_list="$arg"
256 ${dep_list}default_initramfs 258 ${dep_list}default_initramfs
257 ;; 259 ;;
258 "-h") 260 "-h")
259 usage 261 usage
260 exit 0 262 exit 0
261 ;; 263 ;;
262 *) 264 *)
263 case "$arg" in 265 case "$arg" in
264 "-"*) 266 "-"*)
265 unknown_option 267 unknown_option
266 ;; 268 ;;
267 *) # input file/dir - process it 269 *) # input file/dir - process it
268 input_file "$arg" "$#" 270 input_file "$arg" "$#"
269 ;; 271 ;;
270 esac 272 esac
271 ;; 273 ;;
272 esac 274 esac
273 done 275 done
274 276
275 # If output_file is set we will generate cpio archive and gzip it 277 # If output_file is set we will generate cpio archive and gzip it
276 # we are carefull to delete tmp files 278 # we are carefull to delete tmp files
277 if [ ! -z ${output_file} ]; then 279 if [ ! -z ${output_file} ]; then
278 if [ -z ${cpio_file} ]; then 280 if [ -z ${cpio_file} ]; then
279 cpio_tfile="$(mktemp ${TMPDIR:-/tmp}/cpiofile.XXXXXX)" 281 cpio_tfile="$(mktemp ${TMPDIR:-/tmp}/cpiofile.XXXXXX)"
280 usr/gen_init_cpio ${cpio_list} > ${cpio_tfile} 282 usr/gen_init_cpio ${cpio_list} > ${cpio_tfile}
281 else 283 else
282 cpio_tfile=${cpio_file} 284 cpio_tfile=${cpio_file}
283 fi 285 fi
284 rm ${cpio_list} 286 rm ${cpio_list}
285 cat ${cpio_tfile} | gzip -f -9 - > ${output_file} 287 if [ "${is_cpio_compressed}" = "compressed" ]; then
288 cat ${cpio_tfile} > ${output_file}
289 else
290 cat ${cpio_tfile} | gzip -f -9 - > ${output_file}
291 fi
286 [ -z ${cpio_file} ] && rm ${cpio_tfile} 292 [ -z ${cpio_file} ] && rm ${cpio_tfile}
287 fi 293 fi
288 exit 0 294 exit 0
289 295